import QtQuick 2.12
import QtQuick.Controls 2.12
import QtQuick.Layouts 1.12
import QtQuick.Extras 1.4

import "."

Rectangle {
    id: mainWindow
    width: 1280
    height: 800
    color: bgcolor

    property var borderColor: "#09314f"
    property var lightTextColor: "#a4b5c3"
    property var darkTextColor: "#000000"
    property var armColor: "#005596"
    property var bgcolor: "#FFFFFF"
    property var selectedBox: "#4f4029"
    property var currentVolume: 100

    Rectangle {
        anchors.fill: parent
        z: -1
        color: "#73ccea"
    }

    //Laser Engineering Logo
    Image {
        id: leiLogo
        x: 30
        y: 90
        width: 475
        fillMode: Image.PreserveAspectFit
        source: "Images/leiLogo.png"
    }
    Image {
        id: settingsButton
        x: 10; y:750
        source: "Images/settings.png"
    }
    Rectangle {
        id: settingsMenu
        x: Math.round((parent.width - width)/2)
        y: Math.round((parent.height - height) /2)
        z: 2
        width: 275
        height: 315
        color: "#33373A"
        border.color: "black"
        visible: true
        Rectangle {
            x: parent.width-width
            y: 0
            width: 30
            height: 30
            color: gray
            Text {
                anchors.fill: parent
                text: "X"
                font.pointSize: 12
                color: "black"
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
            }
        }
        Text {
            height: 40
            width: parent.width
            text: "Settings"
            color: "white"
            font.pointSize: 14
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
        }
        Rectangle {
            id: pilotMode
            x: 27
            y: 60
            width: 200
            height: 50
            color: bgcolor
            border.color: borderColor
            border.width: 2
            radius: 25
            Text {
                color: darkTextColor
                text: qsTr("Off w/ Footswitch")
                font.pointSize: 17
                anchors.fill: parent
                verticalAlignment: Text.AlignVCenter
                font.family: "Arial"
                horizontalAlignment: Text.AlignHCenter
            }
        }
        Text {
            x: 39; y: 120
            width: 176
            horizontalAlignment: Text.AlignHCenter
            text: "Brightness"
            color: "white"
        }
        Shape {
            x: 14; y: 145
            height: 50; width: 25
            ShapePath {
                id: blightDown
                strokeWidth: 1
                fillColor: "red"
                startX: 25; startY: 0
                PathLine { x: 25; y: 50 }
                PathLine { x: 0; y: 25 }
                PathLine { x: 25; y: 0 }
            }
        }
        Rectangle {
            x: 39; y: 145
            height: 50; width: 176
            color: "transparent"
            border.width: 1
            border.color: "white"
            Rectangle {
                x: 0
                y: 2
                id: bl1
                width: 25
                height: 46
                color: "green"
            }
            Rectangle {
                x: 25
                y: 2
                id: bl2
                width: 25
                height: 46
                color: "green"
            }
            Rectangle {
                x: 50
                y: 2
                id: bl3
                width: 25
                height: 46
                color: "green"
            }
            Rectangle {
                x: 75
                y: 2
                id: bl4
                width: 25
                height: 46
                color: "green"
            }
            Rectangle {
                x: 100
                y: 2
                id: bl5
                width: 25
                height: 46
                color: "green"
            }
            Rectangle {
                x: 125
                y: 2
                id: bl6
                width: 25
                height: 46
                color: "green" //if(mainWindow.currentBrightness>5){"green"}else{"transparent"}
            }
            Rectangle {
                x: 150
                y: 2
                id: bl7
                width: 25
                height: 46
                color: "green"
            }
        }
        Shape {
            x: 215; y: 145
            height: 50; width: 25
            ShapePath {
                id: blightUp
                strokeWidth: 1
                fillColor: "red"
                startX: 0; startY: 0
                PathLine { x: 0; y: 50 }
                PathLine { x: 25; y: 25 }
                PathLine { x: 0; y: 0 }
            }
        }

//Volume Control
        Text {
            x: 82; y: 200
            width: 90
            horizontalAlignment: Text.AlignHCenter
            text: "Volume"
            color: "white"
        }
        Shape {
            x: 57; y: 225
            height: 50; width: 25
            ShapePath {
                id: volDown
                strokeWidth: 1
                fillColor: "red"
                startX: 25; startY: 0
                PathLine { x: 25; y: 50 }
                PathLine { x: 0; y: 25 }
                PathLine { x: 25; y: 0 }
            }
        }
        Rectangle {
            x: 82; y: 225
            height: 50; width: 90
            color: "transparent"
            border.width: 2
            border.color: "white"
            Text {
                text: (mainWindow.currentVolume+"%")
                color: "white"
                anchors.fill: parent
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
                font.pointSize: 18
            }
        }

        Shape {
            x: 173; y: 225
            height: 50; width: 25
            ShapePath {
                id: volUp
                strokeWidth: 1
                fillColor: "red"
                startX: 0; startY: 0
                PathLine { x: 0; y: 50 }
                PathLine { x: 25; y: 25 }
                PathLine { x: 0; y: 0 }
            }
        }
    }//settings Menu
    Rectangle {
        id: serviceMenu
        x:600;y:20
        z:2
        width: 480;height:760
        color: "#33373a"
        visible: false
        Text {
            x: 90
            width: 300;height: 40
            text: "Service Menu"
            color: "white"
            font.pointSize: 18
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
        }

        Rectangle {
            height:30;width: 30
            color: "gray"
            Text {
                anchors.fill: parent
                text: "X"
                font.pointSize: 12
                color: "black"
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
            }
        }//button
        //Diagnostic Input indicators. Should be deleted or commented out in production
        Text {
            height: 20; width: 100
            x: 175; y: 50
            text: "Inputs"
            font.pixelSize: 24
            color: "white"
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
        }
        Rectangle {
            x: 20;y:75
            height: 210; width: 410
            color: "transparent"
            border.color: "white"
            border.width: 2

            StatusIndicator {
                id: fiberStatus
                x: 10
                y: 10
                height: 40
                width: 40
                Text {
                    height: 40
                    color: "white"
                    text: "Fiber In"
                    font.pointSize: 11
                    anchors.left: parent.right
                    anchors.leftMargin: 3
                    verticalAlignment: Text.AlignVCenter
                }
            }
            StatusIndicator {
                 id: airStatus
                 x: 205
                 y: 10
                 height: 40
                 width: 40
                 Text {
                     height: 40
                     color: "white"
                     text: "Air On/Off"
                     font.pointSize: 11
                     anchors.left: parent.right
                     anchors.leftMargin: 3
                     verticalAlignment: Text.AlignVCenter
                 }
             }
            StatusIndicator {
                id: laserStatus
                x: 10
                y: 60
                height: 40
                width: 40
                Text {
                    height: 40
                    color: "white"
                    text: "Laser Ready"
                    font.pointSize: 11
                    anchors.left: parent.right
                    anchors.leftMargin: 3
                    verticalAlignment: Text.AlignVCenter
                }
            }
            StatusIndicator {
                id: gasStatus
                x: 205
                y: 60
                height: 40
                width: 40
                Text {
                    height: 40
                    color: "white"
                    text: "Gas On/Off"
                    font.pointSize: 11
                    anchors.left: parent.right
                    anchors.leftMargin: 3
                    verticalAlignment: Text.AlignVCenter
                }
            }
            StatusIndicator {
                id:interlockStatus
                x: 205
                y: 110
                height: 40
                width: 40
                Text {
                    height: 40
                    color: "white"
                    text: "Interlock OK"
                    font.pointSize: 12
                    anchors.left: parent.right
                    anchors.leftMargin: 3
                    verticalAlignment: Text.AlignVCenter
                }
            }
            StatusIndicator {
                id:shuttleFiberStatus
                x: 10
                y: 110
                height: 40
                width: 40
                Text {
                    height: 40
                    color: "white"
                    text: "Shuttle@Fiber"
                    font.pointSize: 11
                    anchors.left: parent.right
                    anchors.leftMargin: 3
                    verticalAlignment: Text.AlignVCenter
                }
            }
            StatusIndicator {
                id:shuttleArmStatus
                x: 10
                y: 160
                height: 40
                width: 40
                Text {
                    height: 40
                    color: "white"
                    text: "Shuttle@Arm"
                    font.pointSize: 11
                    anchors.left: parent.right
                    anchors.leftMargin: 3
                    verticalAlignment: Text.AlignVCenter
                }
            }
        }
//Status/Debug Log of events that happened
        Text {
            x:20;y:300
            text: "Log:"
            font.pointSize: 10
            color: "white"
            horizontalAlignment: Text.AlignLeft
        }
        Text {
            x: 20;y:320
            height: 370; width: 410
            color: "white"
            text: {
                qStr("4/19 13:27:33 | Interlock Error")
                //TextArea.append("4/19 13:27:34 | Error Cleared")
            }

        }
//log
    }//Service Menu

    Rectangle {
        id: gas
        x: 240
        y: 250
        width: 200
        height: 50
        color: bgcolor
        border.color: borderColor
        border.width: 2
        radius: 25
        Text {
            id: gasText
            color: darkTextColor
            text: qsTr("Gas Off")
            anchors.fill: parent
            font.pixelSize: 24
            verticalAlignment: Text.AlignVCenter
            font.family: "Arial"
            horizontalAlignment: Text.AlignHCenter
        }
    }
    Rectangle {
        id: air
        x: 30
        y: 250
        width: 200
        height: 50
        color: borderColor
        border.color: borderColor
        border.width: 2
        radius: 25
        Text {
            id: airText
            color: lightTextColor
            text: qsTr("Comp. Air On")
            anchors.fill: parent
            font.pixelSize: 24
            verticalAlignment: Text.AlignVCenter
            font.family: "Arial"
            horizontalAlignment: Text.AlignHCenter
        }
    }

    Rectangle {
        id: powUp
        width: powerDisplayBorder.width
        height: this.width
        color: borderColor
        radius: this.width/2
        border.color: borderColor
        border.width: 3
        anchors.left: powerDisplayBorder.left
        anchors.top: powerDisplayBorder.top
        anchors.topMargin: -this.width/2
        Text {
            height: this.width/2
            color: lightTextColor
            text: qsTr("+")
            anchors.right: parent.right
            anchors.left: parent.left
            anchors.top: parent.top
            font.pointSize: parent.width/4
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter
        }
    }
    Rectangle {
        id: powDown
        width: powerDisplayBorder.width
        height: this.width
        color: borderColor
        radius: this.width/2
        anchors.left: powerDisplayBorder.left
        anchors.right: powerDisplayBorder.right
        anchors.bottom: powerDisplayBorder.bottom
        anchors.bottomMargin: -this.width/2
        border.color: borderColor
        border.width: 3
        Text {
            height: this.width/2
            color: lightTextColor
            text: qsTr("-")
            anchors.right: parent.right
            anchors.left: parent.left
            font.pointSize: parent.width/4
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter
            anchors.bottom: parent.bottom
        }
    }
    Rectangle {
        id: powerDisplayBorder
        x: (1280/2) - (this.width/2)
        y: ((800-statusBar.height)/2) + statusBar.height - (this.height/2)
        width: 300
        height: this.width
        color: bgcolor
        border.width: 3
        border.color: borderColor

        Text {
            id: powerDisplay
            height: 240
            text: qsTr("30")
            anchors.right: parent.right
            anchors.left: parent.left
            anchors.top: parent.top
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter
            font.pixelSize: parent.width*0.6
            color: darkTextColor
        }
        Text {
            id: powerUnits
            height: 60
            text: qsTr("watts")
            anchors.bottom: parent.bottom
            anchors.right: parent.right
            anchors.left: parent.left
            verticalAlignment: Text.AlignTop
            horizontalAlignment: Text.AlignHCenter
            font.pixelSize: 50
            color: darkTextColor
        }
    }
    Rectangle {
        id: modeBox
        x: 90
        y: 550
        width: 300
        height: 100
        color: "#00000000"
        border.color: borderColor
        border.width: 3

        Rectangle {
            id: cwBox
            width: parent.width
            height: 50
            color: selectedBox
            border.color: parent.border.color
            border.width: parent.border.width
            anchors.left: parent.left
            anchors.top: parent.top
            Text {
                x: 5
                height: 47
                text: qsTr("CW")
                verticalAlignment: Text.AlignVCenter
                font.pixelSize: 24
                color: cwGraphic.color
            }
            Rectangle {
                id: cwGraphic
                x: 50
                width: 240
                height: 2
                border.width: 0
                anchors.verticalCenter: parent.verticalCenter
                color: "#FF9900"
            }
        }
        Rectangle {
             id: spBox
             width: parent.width
             height: 53
             color: "#00000000"
             border.color: parent.border.color
             border.width: parent.border.width
             anchors.left: parent.left
             anchors.top: cwBox.bottom
             anchors.topMargin: -3
             Text {
                 id: spText
                 x: 5
                 height: 53
                 color: pulsedGraphic.strokeColor
                 text: qsTr("SP")
                 verticalAlignment: Text.AlignVCenter
                 font.pixelSize: 24
             }
             Image {
                 id: pulsedGraphic
                 objectName: "pulsedGraphic"
                 x: 40
                 y: 2
                 width: 260
                 height: 50
                 source: "Images/pulsedGraphicDefault.png"
                 fillMode: Image.PreserveAspectFit
             }
        }
    }
    Rectangle {
        id: cwPulseBox
        width: 103
        height: 103
        color: selectedBox
        anchors.left: modeBox.left
        anchors.top: modeBox.bottom
        anchors.topMargin: -3
        border.color: modeBox.border.color
        border.width: modeBox.border.width
        Rectangle {
            id: cwPulseGraphic1
            x: 10
            y: 10 + cwPulseGraphic2.height
            height: 2
            width: 10
            color: "#FF9900"
            border.width: 0

        }
        Rectangle {
            id: cwPulseGraphic2
            x: cwPulseGraphic1.x + cwPulseGraphic1.width
            y: 12
            height: 80 + cwPulseGraphic1.height
            width: 2
            color: cwPulseGraphic1.color
            border.width: 0

        }
        Rectangle {
            id: cwPulseGraphic3
            x: cwPulseGraphic1.x + cwPulseGraphic1.width
            y: cwPulseGraphic2.y
            height: 2
            width: 70
            color: cwPulseGraphic1.color
            border.width: 0
        }
    }
    Rectangle {
        id: spPulseBox
        width: 100
        height: 103
        color: "#00000000"
        anchors.leftMargin: -3
        anchors.left: cwPulseBox.right
        anchors.top: modeBox.bottom
        anchors.topMargin: -3
        border.color: modeBox.border.color
        border.width: modeBox.border.width
        Rectangle {
            id: spPulseGraphic1
            x: 10
            y: 10 + spPulseGraphic2.height
            height: 2
            width: 10
            color: darkTextColor
            border.width: 0
        }
        Rectangle {
            id: spPulseGraphic2
            x: spPulseGraphic1.x + spPulseGraphic1.width
            y: 12
            height: 80 + spPulseGraphic1.height
            width: 2
            color: spPulseGraphic1.color
            border.width: 0
        }
        Rectangle {
            id: spPulseGraphic3
            x: spPulseGraphic1.x + spPulseGraphic1.width
            y: spPulseGraphic2.y
            height: 2
            width: 15
            color: spPulseGraphic1.color
            border.width: 0
        }
        Rectangle {
            id: spPulseGraphic4
            x: spPulseGraphic3.x + spPulseGraphic3.width
            y: 12
            height: spPulseGraphic2.height
            width: 2
            color: spPulseGraphic1.color
            border.width: 0
        }
        Rectangle {
            id: spPulseGraphic5
            x: spPulseGraphic3.x + spPulseGraphic3.width
            y: 10 + spPulseGraphic2.height
            height: 2
            width: 55
            color: spPulseGraphic1.color
            border.width: 0
        }
    }

    Rectangle {
        id: sprPulseBox
        width: 103
        height: 103
        color: "#00000000"
        anchors.right: modeBox.right
        anchors.top: modeBox.bottom
        anchors.topMargin: -3
        border.color: modeBox.border.color
        border.width: modeBox.border.width
        Rectangle {
            id: sprPulseGraphic1
            x: 10
            y: 10 + sprPulseGraphic2.height
            height: 2
            width: 10
            color: darkTextColor
            border.width: 0
        }
        Rectangle {
            id: sprPulseGraphic2
            x: sprPulseGraphic1.x + sprPulseGraphic1.width
            y: 12
            height: 80 + sprPulseGraphic1.height
            width: 2
            color: sprPulseGraphic1.color
            border.width: 0
        }
        Rectangle {
            id: sprPulseGraphic3
            x: sprPulseGraphic1.x + sprPulseGraphic1.width
            y: sprPulseGraphic2.y
            height: 2
            width: 15
            color: sprPulseGraphic1.color
            border.width: 0
        }
        Rectangle {
            id: sprPulseGraphic4
            x: sprPulseGraphic3.x + sprPulseGraphic3.width
            y: sprPulseGraphic2.y
            height: sprPulseGraphic2.height
            width: 2
            color: sprPulseGraphic1.color
            border.width: 0
        }
        Rectangle {
            id: sprPulseGraphic5
            x: sprPulseGraphic3.x + sprPulseGraphic3.width
            y: 10 + sprPulseGraphic2.height
            height: 2
            width: 10
            color: sprPulseGraphic1.color
            border.width: 0
        }
        Rectangle {
            id: sprPulseGraphic6
            x: sprPulseGraphic5.x + sprPulseGraphic5.width
            y: sprPulseGraphic2.y
            height: sprPulseGraphic2.height
            width: 2
            color: sprPulseGraphic1.color
            border.width: 0
        }
        Rectangle {
            id: sprPulseGraphic7
            x: sprPulseGraphic5.x + sprPulseGraphic5.width
            y: sprPulseGraphic2.y
            height: 2
            width: 15
            color: sprPulseGraphic1.color
            border.width: 0
        }
        Rectangle {
            id: sprPulseGraphic8
            x: sprPulseGraphic7.x + sprPulseGraphic7.width
            y: sprPulseGraphic2.y
            height: sprPulseGraphic2.height
            width: 2
            color: sprPulseGraphic1.color
            border.width: 0
        }
        Rectangle {
            id: sprPulseGraphic9
            x: sprPulseGraphic7.x + sprPulseGraphic7.width
            y: 10 + sprPulseGraphic2.height
            height: 2
            width: 35
            color: sprPulseGraphic1.color
            border.width: 0
        }
    }

    Rectangle {
        id: pulseParameterBox
        x: 115
        y: 325
        width: 250
        height: 200
        color: "#00000000"
        border.width: 3
        border.color: borderColor
        Rectangle {
            id: pulseDisplayBorder
            x: 70
            y: 35
            width: 110
            height: 60
            color: bgcolor
            z: 1
            border.width: 3
            border.color: borderColor

            Text {
                id: pulseDisplay
                x: 0
                y: 0
                width: pulseDisplayBorder.width
                height: 60
                color: darkTextColor
                text: qsTr("0.5")
                z: 2
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignHCenter
                font.pixelSize: 35

                Text {
                    id: pulseUnit
                    x: 0
                    y: 0
                    width: 30
                    height: 60
                    color: darkTextColor
                    text: "s"
                    z: 2
                    verticalAlignment: Text.AlignVCenter
                    horizontalAlignment: Text.AlignRight
                    anchors.right: parent.right
                    anchors.rightMargin: 10
                    font.pixelSize: parent.font.pixelSize
                }
            }

            Text {
                id: pulseDisplayLabel
                width: parent.width
                height: 30
                color: darkTextColor
                text: qsTr("Pulse Width")
                anchors.bottom: parent.top
                verticalAlignment: Text.AlignBottom
                horizontalAlignment: Text.AlignHCenter
                anchors.bottomMargin: 5
                font.pixelSize: 24
            }
        }

        Rectangle {
            id: pulseUpBody
            x: 960
            y: pulseDisplayBorder.y
            width: 30
            height: 60
            color: borderColor
            border.color: this.color
            border.width: 0
            anchors.left: pulseDisplayBorder.right
            Text {
                width: 30
                height: 60
                anchors.left: parent.left
                anchors.leftMargin: 10
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 2
                color: lightTextColor
                text: "+"
                z: 2
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignHCenter
                font.pixelSize: 50
            }
            Rectangle {
                id: pulseUpRound
                width: 60
                height: 60
                color: parent.color
                radius: 30
                border.color: parent.color
                border.width: 3
                anchors.left: parent.right
                anchors.leftMargin: -30
            }
        }


        Rectangle {
            id: pulseDownBody
            x: 755
            y: pulseDisplayBorder.y
            width: 30
            height: 60
            color: borderColor
            anchors.right: pulseDisplayBorder.left
            anchors.rightMargin: 0
            border.color: this.color
            border.width: 0
            Text {
                width: 30
                height: 60
                anchors.left: parent.left
                anchors.leftMargin: -10
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 2
                color: lightTextColor
                text: "-"
                z: 2
                enabled: false
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignHCenter
                font.pixelSize: 50
            }
            Rectangle {
                id: pulseDownRound
                width: 60
                height: 60
                color: parent.color
                radius: 30
                border.color: parent.color
                border.width: 3
                anchors.right: parent.left
                anchors.rightMargin: -30
            }
        }
        Rectangle {
            id: repeatDisplayBorder
            x: 70
            y: 130
            width: 110
            height: 60
            color: bgcolor
            z: 1
            border.width: 3
            border.color: borderColor

            Text {
                id: repeatDisplay
                x: 0
                y: 0
                width: repeatDisplayBorder.width
                height: 60
                color: darkTextColor
                text: qsTr("OFF")
                z: 2
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignHCenter
                font.pixelSize: 35

                Text {
                    x: 0
                    y: 0
                    width: 30
                    height: 60
                    visible: false
                    color: darkTextColor
                    text: "s"
                    z: 2
                    verticalAlignment: Text.AlignVCenter
                    horizontalAlignment: Text.AlignRight
                    anchors.right: parent.right
                    anchors.rightMargin: 10
                    font.pixelSize: parent.font.pixelSize
                }
            }

            Text {
                id: repeatDisplayLabel
                width: parent.width
                height: 30
                color: darkTextColor
                text: qsTr("Cycle Time")
                anchors.bottom: parent.top
                verticalAlignment: Text.AlignBottom
                horizontalAlignment: Text.AlignHCenter
                anchors.bottomMargin: 5
                font.pixelSize: 24
            }
        }

        Rectangle {
            id: repeatUpBody
            x: 960
            y: repeatDisplayBorder.y
            width: 30
            height: 60
            color: borderColor
            border.color: this.color
            border.width: 0
            anchors.left: repeatDisplayBorder.right
            Text {
                width: 30
                height: 60
                anchors.left: parent.left
                anchors.leftMargin: 10
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 2
                color: lightTextColor
                text: "+"
                z: 2
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignHCenter
                font.pixelSize: 50
            }

            Rectangle {
                id: repeatUpRound
                width: 60
                height: 60
                color: parent.color
                radius: 30
                border.color: parent.color
                border.width: 3
                anchors.left: parent.right
                anchors.leftMargin: -30
            }
        }


        Rectangle {
            id: repeatDownBody
            x: 755
            y: repeatDisplayBorder.y
            width: 30
            height: 60
            color: borderColor
            anchors.right: repeatDisplayBorder.left
            anchors.rightMargin: 0
            border.color: this.color
            border.width: 0
            Text {
                width: 30
                height: 60
                anchors.left: parent.left
                anchors.leftMargin: -10
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 2
                color: lightTextColor
                text: "-"
                z: 2
                enabled: false
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignHCenter
                font.pixelSize: 50
            }
            Rectangle {
                id: repeatDownRound
                width: 60
                height: 60
                color: parent.color
                radius: 30
                border.color: parent.color
                border.width: 3
                anchors.right: parent.left
                anchors.rightMargin: -30
            }
        }
    }

    Rectangle {
        id: statusBar
        width: 750
        height: 70
        color: armFiberModeLight.border.color
        anchors.right: parent.right
        anchors.rightMargin: 0
        anchors.left: parent.left
        anchors.leftMargin: 0
        anchors.top: parent.top
        anchors.topMargin: 0
        z: 1
        visible: true

        Text {
            id: statusText
            text: ""
            font.bold: true
            verticalAlignment: Text.AlignBottom
            horizontalAlignment: Text.AlignHCenter
            anchors.fill: parent
            font.pixelSize: 60
        }
    }
    Rectangle {
        id: interlockBar
        height: 3
        color: "#04F408"
        anchors.right: parent.right
        anchors.left: parent.left
        anchors.top: statusBar.bottom
        visible: true
    }
    //The circular "light" on the right of the standby/ready indicator
    Rectangle {
        id: readyLight
        y: standbyArea.y
        z: 3
        width: 100
        height: 100
        color: "#ffee00"
        radius: 50
        anchors.left: standbyArea.right
        anchors.leftMargin: -50
        border.width: 7
        border.color: "#7a7474"

        ColorAnimation on color {
            id: rdyLtRdy
            from: "#ffee00"; to: "#00a854"
            duration: 500
            running: false
        }
        ColorAnimation on color {
            id: rdyLtStndby
            from: "#00a854";to: "#ffee00"
            duration: 500
            running: false
        }
    }
    Rectangle {
        id: standbyArea
        x: 950
        y: 88
        z: 1
        width: 250
        height: 100
        color: "#FFF8A6"
        layer.smooth: true
        state: "standby"

        Text {
            id: standbyText
            y: 0
            state: "standby"
            text: qsTr("STANDBY")
            anchors.left: parent.left
            anchors.leftMargin: 25
            anchors.verticalCenter: parent.verticalCenter
            z: 2
            font.pixelSize: 36
            color: "black"
        }
    }
    Rectangle {
        id: standbyAreaRound
        y: standbyArea.y
        width: 100
        height: 100
        color: standbyArea.color
        radius: 50
        border.color: "#00000000"
        anchors.right: standbyArea.left
        anchors.rightMargin: -50
        z: 0
    }
    //AIMING laser
    Rectangle {
        id: aimingAIntensityBorder
        x: 1015
        y: 709
        width: 120
        height: 60
        color: bgcolor
        z: 1
        border.width: 2
        border.color: borderColor
        Rectangle {
            x: 10
            y: 10
            id: pilot25
            width: 25
            height: 40
            color: "green"
        }
        Rectangle {
            x: 35
            y: 10
            id: pilot50
            width: 25
            height: 40
            color: "red"
        }
        Rectangle {
            x: 60
            y: 10
            id: pilot75
            width: 25
            height: 40
            color: "red"
        }
        Rectangle {
            x: 85
            y: 10
            id: pilot100
            width: 25
            height: 40
            color: "red"
        }
    }

    Rectangle {
        id: aimAUp
        y: aimingAIntensityBorder.y
        width: 30
        height: 60
        color: borderColor
        anchors.left: aimingAIntensityBorder.right
        border.color: this.color
        border.width: 0
        Text {
            width: 30
            height: 60
            z: 1
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 2
            color: lightTextColor
            text: "+"
            font.pointSize: 35
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
        }
        Rectangle {
            id: aimIntensityUpRound
            width: 60
            height: 60
            color: parent.color
            radius: 30
            border.color: parent.color
            border.width: 3
            anchors.left: parent.right
            anchors.leftMargin: -30
        }
    }
    Rectangle {
        id: aimADown
        y: aimingAIntensityBorder.y
        width: 30
        height: 60
        color: borderColor
        anchors.right: aimingAIntensityBorder.left
        border.color: this.color
        border.width: 0
        Text {
            width: 30
            height: 60
            z: 1
            anchors.left: parent.left
            anchors.leftMargin: -10
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 2
            color: lightTextColor
            text: "-"
            font.pointSize: 35
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
        }
        Rectangle {
            id: aimIntensityDownRound
            width: 60
            height: 60
            color: parent.color
            radius: 30
            border.color: parent.color
            border.width: 3
            anchors.right: parent.left
            anchors.rightMargin: -30
        }
    }
    Rectangle {
        id: aimingBeam
        x: 975
        y: 579
        width: 200
        height: 50
        color: bgcolor
        border.color: borderColor
        border.width: 2
        radius: 25
        Text {
            color: borderColor
            text: qsTr("Aiming Beam")
            anchors.fill: parent
            font.pixelSize: 24
            verticalAlignment: Text.AlignVCenter
            font.family: "Arial"
            horizontalAlignment: Text.AlignHCenter
        }
    }
    Rectangle {
        id: aimMode
        x: 975
        y: 644
        width: 200
        height: 50
        radius: 25
        color: borderColor
        border.color: borderColor
        border.width: 2
        Text {
            id: aimModeText
            text: qsTr("CONT")
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter
            font.pixelSize: 28
            anchors.fill: parent
            color: lightTextColor
        }
    }

    Rectangle {
        id: aimSlider
        x: aimMode.x - 15
        y: aimMode.y -5
        width: 60
        height: 60
        color: "#000000"
        radius: 30
        z: 1
    }



    Rectangle {
        id: armFiberModeLight
        x: 940
        y: 250
        width: 270
        height: 220
        color: "#00000000"
        radius: 40
        border.width: 5
        border.color: armColor

        Rectangle {
            id: beamDeliveryFrame
            x: 10
            y: 10
            width: 250
            height: 200
            color: "#00000000"
            radius: 30
            border.width: 2
            border.color: borderColor
            Image {
                id: beamDeliveryDisplay
                anchors.fill: parent
                source: "Images/armIcon.png"
                fillMode: Image.PreserveAspectFit
            }
            Text {
                id: deliveryModeText
                color: darkTextColor
                text: "ARM"
                font.pointSize: 18
                horizontalAlignment: Text.AlignRight
                anchors.right: parent.right
                anchors.rightMargin: 20
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 3

            }
        }
    }
}




