#ifndef BEEPER_H
#define BEEPER_H

#include <QObject>

#include <alsa/asoundlib.h>
#include <alsa/control.h>

class Beeper : public QObject
{
    Q_OBJECT
    Q_PROPERTY(QString soundFile READ soundFile WRITE setSoundFile NOTIFY soundFileChanged)
public:
    explicit Beeper(QObject *parent = nullptr);
    ~Beeper();

    QString soundFile(void);

signals:
    void soundFileChanged();

public slots:
    void beep(void);
    void setSoundFile(const QString &path);
    void setVolume(int);

private:
    snd_pcm_t           *m_playbackHandle;
    uint8_t             *m_wavePtr;
    snd_pcm_sframes_t   m_waveFrames;
    QString             currentSoundFile;

};

#endif // BEEPER_H
