#include "mystyle.h"
#include <QDebug>

StyleValues::StyleValues(QObject *parent): QQmlPropertyMap(this, parent) {
  qDebug("Style Values Instantiation");
  setObjectName("style");
  insert("bgcolor", "#FFFFFF");//Backgorund color for main window
  insert("borderColor","#09314f");//Border Color
  insert("textColor","#000000");//Text color, slider color, and icon color
  insert("darkTextColor","#000000");//Text color for light backgrounds
  insert("lightTextColor","#a4b5c3");//Text color for dark backgrounds
  insert("selectedBox","#4f4029");//Color for when boxes are selected
  insert("pressedColor","#8b3214");//Color when hollow buttons are pressed
  insert("sliderColor","#000000");
  insert("fiberColor","#ff9900");//Color for fiber
  insert("armColor","#005596");//Color for arm
  insert("standbyColor","#fff8a6");//Yellow standby color
  insert("readyColor","#6aa889");//Green Ready Color
  insert("armMode",QVariant::fromValue(true)); //if the system is in arm or fiber mode
  insert("pilotWhileOn",QVariant::fromValue(true)); //if the pilot laser will stay on while lasing
  insert("aimHist",QVariant::fromValue(false)); //Aiming beam hysteresis, keeps track of if the aiming laser was on before lasing
  insert("aimOn", QVariant::fromValue(false)); //True if aiming beam is on
  insert("aimingButton",QVariant::fromValue(true)); //If the aiming beam is supposed to be active (button pressed or not)
  insert("airStatus",QVariant::fromValue(false)); //If the air is supposed to be active (button pressed or not)
  insert("gasStatus",QVariant::fromValue(false)); //If the external tank is supposed to be active (button pressed or not)
  insert("machineState","standby"); //If the machine is in standby or ready
  insert("laserReady",QVariant::fromValue(false)); //Laser Ready Input
  insert("shuttlePos", "arm"); //What position the shuttle is in. "arm", "fiber", or "none"
  insert("interlock",QVariant::fromValue(true)); //If the interlock input is active or not
  insert("fiberStatus",QVariant::fromValue(false)); //If there is a fiber plugged in (fiber input)
  insert("lasing", QVariant::fromValue(false)); //If the laser is currently Lasingz
  insert("errorValue",0); //variable for storing the error codes concurrently happening

  //Teal #73CCCEA
}

void StyleValues::startEngine() {
  qDebug() << "Start ENGINE STYLE " << Q_FUNC_INFO;
}

QString StyleValues::getColor(const QString name) {
  QVariant tempColor = value(name);
  return tempColor.value < QString > ();
}
