#ifndef SERIALCONTROLLER_H
#define SERIALCONTROLLER_H

#include <QObject>
#include <QSerialPort>
#include <QString>
#include <QSettings>
#include <QDebug>

class serialcontroller : public QObject
{
    Q_OBJECT
public:
    explicit serialcontroller(QObject *parent = nullptr);
    ~serialcontroller();

signals:
    void messageAvailable(QStringList msg);
    void modeChange(QVariant modeChange, QVariant val);
    void powerUpdate(QVariant power); //Update Power number display
    void repUpdate(QVariant repeat); //Update cycle time display
    void pulseUpdate(QVariant pulse); //Update pulse width display
    void statusbar(); //Update various status bar
    void readyStandby(QVariant ready); //Update ready and standby button
    void lasing(QVariant lase);
    void error(QVariant error_type);

public slots:
    void send(QString msg);

private slots:
    void onSerialReadyRead(void);

private:
    QSerialPort m_port;
};

#endif // SERIALCONTROLLER_H
